<?php
/*
 * Name:              WP-RePass
 * Version:           1.0
 * Author:            Leonid Tushov
 * Author URI:        https://tushov.ru
 * License:           GPL-3.0+
*/

require( dirname( __FILE__ ) . '/wp-load.php' );

$task = $_REQUEST['t'];

if ($task) {
	$func = 'wp_repass_' . $task;
	if ( function_exists($func) )
		call_user_func($func);
} else {
	wp_repass_index();
}

function wp_repass_del()
{
	@unlink(__FILE__);

	wp_repass_header();
	?>
	<form class="repass_set">
	<?php if ( is_file(__FILE__) ) { ?>
		<p style="color:red;margin-top:20px;font-weight: bold;font-size:120%;">Внимание! Файл <u><?php echo basename(__FILE__); ?></u> не был автоматически удалён из корневой папки данного сайта. Пожалуйста, удалите данный файл вручную используя FTP или файловый менеджер в панели Вашего хостинга.</p>
	<?php } else { ?>
		<h3>Файл <?php echo basename(__FILE__); ?> успешно удален!</h3>
	<?php } ?>
	</form>
	<?php
	wp_repass_footer();
}


function wp_repass_set()
{
	$user_id = (int) $_POST['user_id'];
	if ($user_id)
		wp_set_password( $_POST['pwd'], $user_id );

	@unlink(__FILE__);

	$is_file = is_file(__FILE__);

	wp_repass_header();
	?>
	<form class="repass_set">
		<h3>Пароль успешно изменен!</h3>
		<p>Попробуйте войти в панель администрирования WordPress используя новый пароль:</p>
		<p><a<?php echo $is_file ? ' target="_blank"' : ''; ?> style="float:none;" class="button button-primary button-large" href="<?php echo wp_login_url(); ?>">Войти</a></p>
		<?php if ( $is_file ) { ?>
			<p style="color:red;margin-top:20px;font-weight: bold;font-size:120%;">Внимание! Файл <u><?php echo basename(__FILE__); ?></u> не был автоматически удалён из корневой папки данного сайта. Пожалуйста, удалите данный файл вручную используя FTP или файловый менеджер в панели Вашего хостинга.</p>
		<?php } ?>
	</form>
	<?php
	wp_repass_footer();
}

function wp_repass_index() {
	$admin_users = get_users(
		array(
			'role'=>'administrator',
			'fields'=>array('ID','user_login','user_email'),
		)
	);
	wp_repass_header();
?>
		<form name="loginform" action="?t=set" id="loginform" method="post">
			<p>
				<label for="user_login">Имя пользователя-администратора<br />
				<?php if ( count($admin_users) ) { ?>
				<select name="user_id" class="input">
					<?php foreach ($admin_users as $_user) {
						echo "<option value=\"{$_user->ID}\">{$_user->user_login} ({$_user->user_email})</option>";
					} ?>
				</select>
				<?php } else { ?>
				<input type="text" name="log" id="user_login" class="input" value="" size="20" /></label>
				<?php } ?>
			</p>
			<p>
				<label class="new_pass" for="user_pass">Новый пароль ( <a href="javascript:wp_repass_set_passsword();void(0);">сгенерировать?</a> ):<br />
				<input type="password" name="pwd" id="user_pass" class="input" value="" size="20" minlength="4" />
				<span id="showhide_id" title="Показать символы?" class="dashicons dashicons-visibility" onclick="wp_repass_showhidepass();"></span>
				</label>
			</p>
			<p class="submit">
				<input type="submit" name="wp-submit" id="wp-submit" class="button button-primary button-large" value="Изменить пароль" />
			</p>
		</form>
<?php
	wp_repass_footer();
exit(); 
}

function wp_repass_header() { ?>
<!DOCTYPE html>
<!--[if IE 8]>
<html xmlns="http://www.w3.org/1999/xhtml" class="ie8" lang="ru-RU">
<![endif]-->
<!--[if !(IE 8) ]><!-->
<html xmlns="http://www.w3.org/1999/xhtml" lang="ru-RU">
<!--<![endif]-->
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<title>WP-RePass 1.0 - изменение пароля администратора WordPress</title>
	<link rel='stylesheet' href='<?php echo home_url('/wp-admin/load-styles.php?c=1&amp;dir=ltr&amp;load%5B%5D=dashicons,buttons,forms,l10n,login'); ?>' type='text/css' media='all' />
	<meta name="viewport" content="width=device-width" />
	<style type="text/css">
	#login { width: 500px !important; }
	p#nav {padding:0 !important; display: inline-block; width:49%; text-align: right;}
	p#backtoblog { padding:0 !important; display: inline-block; width:49%;}
	#author {position: fixed; left: 20px; bottom: 20px; color: #aaa;}
	#author a { color: #aaa; }
	.new_pass {position: relative;}
	#showhide_id {display: block; width: 20px; height: 20px; position: absolute; right: 15px; bottom: 5px;}
	form.repass_set p {padding: 15px 0px 10px 0px;}
	</style>
	<script type="text/javascript">
	function wp_repass_showhidepass()
	{
		if (window.showhidepass != 'show') {
			document.getElementById('user_pass').type="text";
			window.showhidepass = 'show';
			document.getElementById("showhide_id").classList.remove('dashicons-visibility');
			document.getElementById("showhide_id").classList.add('dashicons-hidden');
			document.getElementById("showhide_id").title = 'Скрыть символы?';
		} else {
			document.getElementById('user_pass').type="password";
			window.showhidepass = 'hide';
			document.getElementById("showhide_id").classList.remove('dashicons-hidden');
			document.getElementById("showhide_id").classList.add('dashicons-visibility');
			document.getElementById("showhide_id").title = 'Показать символы?';
		}
	}
	function wp_repass_gen_passsword() {
	    var charset = 'qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM0123456789()*&%$#@_-+={}';
	    var pass = '';
	    for (var i = 0, n = charset.length; i < 11; ++i) {
	        pass += charset.charAt(Math.floor(Math.random() * n));
	    }
	    return pass;
	}
	function wp_repass_set_passsword()
	{
		var pass = wp_repass_gen_passsword();
		document.getElementById('user_pass').type="text";
		window.showhidepass = 'show';
		document.getElementById("showhide_id").classList.remove('dashicons-visibility');
		document.getElementById("showhide_id").classList.add('dashicons-hidden');
		document.getElementById("showhide_id").title = 'Скрыть символы?';
		document.getElementById('user_pass').value = pass;
	}
	</script>
</head>
<body class="login login-action-login wp-core-ui locale-ru-ru">
	<div id="login">
		<h1><a href="https://ru.wordpress.org/" title="Сайт работает на WordPress" tabindex="-1">Сайт работает на WordPress</a></h1>
<?php }

function wp_repass_footer() { ?>
		<p id="backtoblog"><a href="<?php echo home_url('/'); ?>">&larr; Назад к сайту &laquo;blog.infoforum.ru&raquo;</a></p>
		<?php if (!$_REQUEST['t']) { ?>
		<p id="nav"><a href="?t=del" style="color:red; font-weight: bold;">Удалить файл wp-repass.php?</a></p>
		<?php } ?>
	</div>
	<div class="clear"></div>
	<p id="author">&copy; <a target="_blank" title="Перейти на сайт автора данного скрипта?" href="https://tushov.ru">tushov.ru</a> / <a title="Справка и документация..." target="_blank" href="https://tushov.ru/wordpress/wp-repass">справка</a> </p>
</body>
</html>
<?php }